' -- TVGids.vbs
' -- Versie 2.1
'
' -- By Triplesix

TVGuideUrl      = "http://www.tvgids.nl/nustraks/allezenders/"
SamurizeDir     = CreateObject("WScript.Shell").RegRead("HKCU\Software\Serious Samurize\General\DirPath")
ConfigFile      = SamurizeDir & "Scripts\TVGids_config.txt"

Set Http        = CreateObject("WinHttp.WinHttpRequest.5.1")
Set FileSystem  = CreateObject("Scripting.FileSystemObject")

Function RemoveTags(S)
	Dim strNew
	Dim strChar
	Dim strLen, CharPos

	' Remove HTML tags
	Do Until InStr(S, "<") = 0
		StrStart = InStr(S, "<")
		StrEnd   = InStr(S, ">") + 1
		Tag      = Mid(S, StrStart, StrEnd - StrStart)
		S        = Replace(S, Tag, "")
	Loop

	' Remove all special chars
	strLen = Len(S)
	strNew = ""
	For CharPos = 1 To strLen
		strChar = Mid(S, CharPos, 1)
		If Asc(strChar) > 31 Then
			strNew = strNew & strChar
		End If
	Next

	RemoveTags = Trim(strNew)
End Function


Function TVGids()
	Dim TimeString1, TimeString2
	Dim ProgramString1, ProgramString2
	Dim DetailsStart, DetailsEnd

	' Read config
	Set ReadConfig = FileSystem.OpenTextFile(ConfigFile, 1, False)
	ConfigLines    = Split(ReadConfig.ReadAll, vbCrLf)
	ReadConfig.Close

	Dim ConfigGroup
	Dim Channels()
	Dim OutputFile
	Dim ErrorConnectionMsg
	Dim ErrorDataMsg
	Dim NoProgramMsg
	Dim OutputLines()

	ConfigGroup  = ""
	ChannelCount = 0
	LineCount    = 0
	For Each ConfigLine in ConfigLines
		ConfigLine = Trim(ConfigLine)
		SearchPos = InStr(ConfigLine,"#")
		If SearchPos > 0 Then
			ConfigLine = Trim(Left(ConfigLine,SearchPos-1))
		End If
		SearchPos = InStr(ConfigLine,"[")
		If SearchPos = 1 Then
			SearchPos = InStr(ConfigLine,"]")
			ConfigGroup = Mid(ConfigLine, 2, SearchPos-2)
		Else
			If ConfigLine <> "" Then
				If ConfigGroup = "channels" Then
					ReDim Preserve Channels(ChannelCount)
					Channels(ChannelCount) = ConfigLine
					ChannelCount = ChannelCount+1
				End If
				If ConfigGroup = "config" Or ConfigGroup = "messages" Or ConfigGroup = "output" Then
					KeyValue = Split(ConfigLine,"=", 2)
					KeyValue(0) = Trim(KeyValue(0))
					KeyValue(1) = Trim(KeyValue(1))
					If InStr(KeyValue(1),chr(34)) = 1 And InstrRev(KeyValue(1),chr(34)) = Len(KeyValue(1)) Then
						KeyValue(1) = Mid(KeyValue(1),2,Len(KeyValue(1))-2)
					End If
				End If
				If ConfigGroup = "config" Then
					If KeyValue(0) = "outputfile" Then OutputFile = KeyValue(1) End If
				End If
				If ConfigGroup = "messages" Then
					If KeyValue(0) = "error_connect" Then ErrorConnectionMsg = KeyValue(1) End If
					If KeyValue(0) = "error_data" Then ErrorDataMsg = KeyValue(1) End If
					If KeyValue(0) = "noprogram" Then NoProgramMsg = KeyValue(1) End If
				End If
				If ConfigGroup = "output" Then
					If InStr(KeyValue(0),"line") = 1 Then
						ReDim Preserve OutputLines(LineCount)
						OutputLines(LineCount) = KeyValue(1)
						LineCount = LineCount+1
					End If
				End If
			End If
		End If
	Next

	' Download HTML page
	Http.Open "GET",TVGuideUrl, False
	Http.Send
	Http.WaitForResponse(60)
	HtmlResult = Http.ResponseText

	' Open output file for writing
	Set WriteTVGuide = FileSystem.CreateTextFile(OutputFile, True, False)

	' Check HTML title
	If InStr(HtmlResult, "<title>TVGids.nl") > 0 Then
		' Info extraction for each specified channel
		For Each Channel in Channels
			' Search for channel in HTML
			SearchPos  = InStr(HtmlResult, "<td class=""channel"">" & Channel & "</td>")
			If SearchPos = 0 Then
				TimeString1    = "xx:xx"
				ProgramString1 = ErrorDataMsg
				TimeString2    = "xx:xx"
				ProgramString2 = ErrorDataMsg
			Else
				' Get start and end position for each data field
				TimeStart   = InStr(SearchPos, HtmlResult, "<td class=""time"">")
				TimeEnd     = InStr(TimeStart, HtmlResult, "</td>")
				TimeString1 = RemoveTags( Mid(HtmlResult, TimeStart, TimeEnd - TimeStart) )

				If TimeString1 <> "" Then
					ProgramStart   = InStr(SearchPos, HtmlResult, "<td class=""title"">")
					ProgramEnd     = InStr(ProgramStart, HtmlResult, "</td>" )
					ProgramString1 = RemoveTags( Mid(HtmlResult, ProgramStart, ProgramEnd - ProgramStart) )

					DetailsStart  = InStr(SearchPos, HtmlResult, "<a href=") + 9
					DetailsEnd    = InStr(DetailsStart, HtmlResult, ">") - 2
				Else
					TimeString1    = "--:--"
					ProgramString1 = NoProgramMsg
				End If

				' Search for next program
				SearchPos = InStr(SearchPos, HtmlResult, "<td class=""spacer"">")

				' Get start and end position for each data field
				TimeStart   = InStr(SearchPos, HtmlResult, "<td class=""time"">")
				TimeEnd     = InStr(TimeStart, HtmlResult, "</td>")
				TimeString2 = RemoveTags( Mid(HtmlResult, TimeStart, TimeEnd - TimeStart) )

				If TimeString2 <> "" Then
					ProgramStart   = InStr(SearchPos, HtmlResult, "<td class=""title"">")
					ProgramEnd     = InStr(ProgramStart, HtmlResult, "</td>" )
					ProgramString2 = RemoveTags( Mid(HtmlResult, ProgramStart, ProgramEnd - ProgramStart) )

					DetailsStart  = InStr(SearchPos, HtmlResult, "<a href=") + 9
					DetailsEnd    = InStr(DetailsStart, HtmlResult, ">") - 2
				Else
					TimeString2    = "--:--"
					ProgramString2 = NoProgramMsg
				End If
			End If
			For Each OutputLine In OutputLines
				OutputLine = Replace(OutputLine, "%zender%", Channel)
				OutputLine = Replace(OutputLine, "%tijd1%", TimeString1)
				OutputLine = Replace(OutputLine, "%titel1%", ProgramString1)
				OutputLine = Replace(OutputLine, "%tijd2%", TimeString2)
				OutputLine = Replace(OutputLine, "%titel2%", ProgramString2)
				WriteTVGuide.WriteLine(OutputLine)
			Next
		Next
	Else
		WriteTVGuide.WriteLine(ErrorConnectionMsg)
	End If

	WriteTVGuide.Close
End Function
